import std.zlib;
import std.file;
import std.stdio;

int index = 0;
char[] data;

long get_long() {
  long ret = 0;
  for (int i = 0; i < 8; i++) {
    ret |= cast(long)data[index] << cast(long)((7 - i) * 8);
    index++;
  }
  return ret;
}

int get_int() {
  int ret = 0;
  for (int i = 0; i < 4; i++) {
    ret |= data[index] << ((3 - i) * 8);
    index++;
  }
  return ret;
}

int get_byte() {
  int ret = 0;
  ret |= data[index];
  index++;
  return ret;
}

void main() {
  byte[] rdata = cast(byte[])read("savedata");
  data = cast(char[])uncompress(rdata);
  FILE *fp = fopen("save.txt", "w");
  fprintf(fp, "Max Zanki:%d\n", get_byte());
  fprintf(fp, "Max Bomb:%d\n", get_byte());
  fprintf(fp, "Max Ink:%d\n", get_int());
  fprintf(fp, "Max Credit:%d\n", get_byte());
  fprintf(fp, "\n");

  fprintf(fp, "Easy HighScore   :%10lld\n", get_long());
  fprintf(fp, "Easy Clear:%d\n", get_int());
  fprintf(fp, "Normal HighScore :%10lld\n", get_long());
  fprintf(fp, "Normal Clear:%d\n", get_int());
  fprintf(fp, "Panic HighScore  :%10lld\n", get_long());
  fprintf(fp, "Panic Clear:%d\n", get_int());
  fprintf(fp, "Extra HighScore  :%10lld\n", get_long());
  fprintf(fp, "Extra Clear:%d\n", get_int());
  get_long();
  get_int();
  fprintf(fp, "\n");

  fprintf(fp, "Game Over:%d\n", get_int());
  fprintf(fp, "Correct Item Max:%d\n", get_int());
  fprintf(fp, "\n");

  fprintf(fp, "Easy Nocontinue Clear:%d\n", get_byte());
  fprintf(fp, "Easy NoMiss Clear:%d\n", get_byte());
  fprintf(fp, "Easy NoBomb Clear:%d\n", get_byte());
  fprintf(fp, "Easy BossPerfect Clear:%d\n", get_byte());
  fprintf(fp, "Normal Nocontinue Clear:%d\n", get_byte());
  fprintf(fp, "Normal NoMiss Clear:%d\n", get_byte());
  fprintf(fp, "Normal NoBomb Clear:%d\n", get_byte());
  fprintf(fp, "Normal BossPerfect Clear:%d\n", get_byte());
  fprintf(fp, "Panic Nocontinue Clear:%d\n", get_byte());
  fprintf(fp, "Panic NoMiss Clear:%d\n", get_byte());
  fprintf(fp, "Panic NoBomb Clear:%d\n", get_byte());
  fprintf(fp, "Panic BossPerfect Clear:%d\n", get_byte());
  fprintf(fp, "Extra Nocontinue Clear:%d\n", get_byte());
  fprintf(fp, "Extra NoMiss Clear:%d\n", get_byte());
  fprintf(fp, "Extra NoBomb Clear:%d\n", get_byte());
  fprintf(fp, "Extra BossPerfect Clear:%d\n", get_byte());
  get_byte();
  get_byte();
  get_byte();
  get_byte();
  fprintf(fp, "\n");

  // NoMove, NoDrawing
  for (int i = 0; i < 20; i++) { get_byte(); }

  // stoicPlay;
  get_byte();
  // inkMinClear
  get_byte();
  // itemBoxFullOpen
  get_byte();

  int playtime = cast(int)get_long();
  int hour = playtime / 3600;
  int minute = (playtime / 60) % 60;
  int second = playtime % 60;
  fprintf(fp, "PlayTime %3d:%02d:%02d\n", hour, minute, second);

  fprintf(fp, "Star Break:%d\n", get_int());
}
